﻿using Infragistics.Win.UltraWinEditors;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication10
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.SuspendLayout();

            this.textBox1.Top = this.ultraDateTimeEditor1.Top + 3;
            this.textBox1.Left = this.ultraDateTimeEditor1.Left + 3;
            this.textBox1.Height = this.ultraDateTimeEditor1.Height - 5;
            this.textBox1.Width = this.ultraDateTimeEditor1.Width - 15;
            this.textBox1.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.textBox1.Parent = this;
            this.textBox1.Visible = true;

            CultureInfo culture = (CultureInfo)(Thread.CurrentThread.CurrentCulture.Clone());
            GregorianCalendar gregLocalCal = new System.Globalization.GregorianCalendar();
            gregLocalCal.CalendarType = GregorianCalendarTypes.Localized;
            culture.DateTimeFormat.Calendar = gregLocalCal;

            this.ultraDateTimeEditor1.Controls.Add(this.textBox1);
            this.ultraDateTimeEditor1.FormatProvider = culture.DateTimeFormat;
            this.ultraDateTimeEditor1.FormatString = culture.DateTimeFormat.LongDatePattern.ToString();
            this.ultraDateTimeEditor1.AlwaysInEditMode = false;
            this.ultraDateTimeEditor1.Value = string.Empty;
            this.ultraDateTimeEditor1.ValueChanged += new EventHandler(dateTimeEditor_ValueChanged);
            this.ResumeLayout(false);
        }

        private void Form1_Load(object sender, System.EventArgs e)
        {
            DataTable dt = new DataTable("dt");
            dt.Columns.Add("No");
            dt.Columns.Add("TitleName");
            dt.Columns.Add("morning");
            dt.Columns.Add("noon");
            dt.Columns.Add("night");

            DataRow dr = dt.NewRow();
            dr["TitleName"] = "Title１";
            dr["morning"] = "aa";
            dr["noon"] = "bb";
            dr["night"] = "cc";

            dt.Rows.Add(dr);

            this.ultraGrid1.DataSource = dt;

            Editor editor = new Editor(this.ultraDateTimeEditor1, this.textBox1);
            ColumnsCollection columns = this.ultraGrid1.DisplayLayout.Bands[0].Columns;
            columns["No"].Editor = editor;
        }

        private void dateTimeEditor_ValueChanged(object sender, EventArgs e)
        {
            UltraDateTimeEditor strDate = sender as UltraDateTimeEditor;

            CultureInfo culture = (CultureInfo)(Thread.CurrentThread.CurrentCulture.Clone());
            GregorianCalendar gregLocalCal = new System.Globalization.GregorianCalendar();
            gregLocalCal.CalendarType = GregorianCalendarTypes.Localized;
            culture.DateTimeFormat.Calendar = gregLocalCal;

            this.textBox1.Text = ((DateTime)strDate.Value).ToString(culture);
        }
    }
}
